function Pmain(profile)
% profile = 'ic_mvn_0.10_10_50.mat';

minwin = 5;
maxwin = 20;
dim = 10;
kmax = 2000;
m0 = 50;
tau = 0;
delta = 0;
alphaerr = 0.005;
nbound = 1000;
disttype = 1;
distparams = 1;
lambda = 0;
repNum = 5;
% batchrun = 50;

c=parcluster;
matlabpool(c);

load(profile);
% nbound = 1000;
% repNum = 8;
tic;

runlen = zeros(1, repNum);
fname = sprintf('%s.txt', filename);

seed=sum(100*clock);  % get seed for current Pmain1 according to current time
% set seed for this Pmain1, and distribute streamindex for different cores
spmd
  RandStream.setGlobalStream(RandStream.create('mrg32k3a','seed',seed,'NumStreams',numlabs,'StreamIndices',labindex));
end

try
    parfor i = 1 : repNum
        while true
           data = RandomSample(m0+kmax, disttype, distparams);
           runlen(i) = RobustDFEWMA(minwin, maxwin, dim, kmax, m0, tau, delta, alphaerr, nbound, lambda, data);
           if runlen(i) > tau
             break;
           end
        end

	fid = fopen(fname,'a','n');
        fprintf(fid, '%d\r\n', runlen(i));
        fclose(fid);
    end
catch err
    display(err.identifier);
    fclose('all');
end

save(filename);
% display(filename);
toc;
fclose('all');
matlabpool close;
exit;
end
